

#include <plib.h>
#include "adc.h"
char bcd10000 =0;
char bcd1000 =0;
char bcd100 =0 ;
char bcdtens =0 ;
char bcdunits =0;
int average =0;

int initADC( int pin)
{
	AD1CON1bits.ADON = 0; // turn off the ADC
  
      /* Configure onlt one Analog pin at a time
       * set ANSELA or ANSELB, and AD1CHS based upon pin
       * PIC32MX250F128B piout ony accepts the following pin for analog
       * pin  name   AH1CHS         ANSELB         ANSELA
       * 2   AN0/RA0     0                       1
       * 3  AN1/RA1    0x10000                   2
       * 4  AN2/RB0    0x20000      1
       * 5  AN3/RB1    0x30000      2
       * 6  AN4/RB2    0x40000      4
       * 7  AN5/RB3    0x50000      8
       * 24 AN11/RB13  0xb0000      0x2000
       * 25 AN10/RB14  0xa0000      0x4000
       * 26 AN9/RB15   0x90000      0x8000
      */
        switch (pin) {

            case (2): //AN0
                TRISAbits.TRISA0=1;
                AD1CHS =0x00000;
                ANSELA =1;
                ANSELB =0;
                break;
            case (3): //AN1
                TRISAbits.TRISA1=1;
                AD1CHS =0x10000;
                ANSELA =2;
                ANSELB =0;
                break;
            case (4): //AN2
                TRISBbits.TRISB0=1;
                AD1CHS =0x20000;
                ANSELA =0;
                ANSELB =1;
                break;
            case (5): //AN3
                TRISBbits.TRISB1=1;
                AD1CHS =0x30000;
                ANSELA =0;
                ANSELB =2;
                break;
            case (6): //AN4
                TRISBbits.TRISB2=1;
               AD1CHS =0x40000;
               ANSELA =0;
               ANSELB =4;
                break;
            case (7): //AN5
                TRISBbits.TRISB3=1;
               AD1CHS =0x50000;
               ANSELA =0;
               ANSELB =8;
                break;
            case (24): //AN11
                TRISBbits.TRISB13=1;
               AD1CHS =0xb0000;
               ANSELA =0;
               ANSELB =0x2000;
                break;
            case (25): //AN10
                TRISBbits.TRISB14=1;
               AD1CHS =0xa0000;
               ANSELA =0;
               ANSELB =0x4000;
                break;
            case (26): //AN9
                TRISBbits.TRISB15=1;
               AD1CHS =0x90000;
               ANSELA =0;
               ANSELB =0x8000;
                break;
            default: //UNKNOWN
                return (0); //return error
        }
    AD1CON1 = 0x00E0;   // auto convert after end of sampling
    AD1CSSL = 0;        // no scanning required
    AD1CON3 = 0x1F02;   // system clock,max sample time = 31Tad, Tad = 2 x Tcy = 125ns >75ns
    AD1CON2 = 0;        // use MUXA, AVss and AVdd are used as Vref+/-
    AD1CON1bits.ADON = 1; // turn on the ADC
    return 1;
} //initADC
int readADC(void)
{

           //AD1CHS  = pin;            // select analog input channel based upon I/o epxansion pin

    AD1CON1bits.SAMP = 1;       // start sampling, automatic conversion will follow
    while (!AD1CON1bits.DONE);   // wait to complete the conversion
    return ADC1BUF0;            // read the conversion result
} // readADC




void binary_to_ASCIIconvert( int n) {
bcd10000 =0x00;
bcd1000=0x00;
bcd100 =0x00;
bcdtens =0x00;
bcdunits =0x00;
while (n>=10000) {
n = n-10000;
bcd10000 =bcd10000+1;
}
while (n>=1000) {
n = n-1000;
bcd1000 =bcd1000+1;
}
while (n>=100) {
n = n-100;
bcd100 =bcd100+1;
}
while (n>=10) {
n = n-10;
bcdtens =bcdtens+1;
}

 bcdunits =n;
bcd10000 =bcd10000+0x30;
bcd1000 =bcd1000+0x30;
bcd100 =bcd100+0x30;
bcdtens =bcdtens+0x30;
bcdunits =bcdunits+0x30;
}
//performs running average
int averagevalue (void) {
	
	average =0;
	average = readADC();
	average = average +readADC();
	average = average +readADC();
	average = average +readADC();
	average = average/4;
	return average;


}
