//initialize the ESP 8266 module

#define _SUPPRESS_PLIB_WARNING
#include <plib.h>
#include "espinitializer.h"
#include "CONU1.h"
#include "CONU2.h"
#include <string.h>
#include "delay.h"



void ESPinit(char *SSID, char *password, char *s)
{
    unsigned char connection=0;             //If connected to wifi
    clrscr1();
    putsU1("ready to rumble");

    putsU2("AT+RST");
    do {
        delay(1500);
        if (strstr(s, "OK") != NULL) {
            putsU1("ESP8266 Reset & Ready");
            clear_display(); //clear the LCD display
            position_cursor(0); //position cursor to row 1
            write_string_LCD((char*) "Reset & Ready"); //outputs Message 
            break;
        } else if (strstr(s, "FAIL") != NULL) {
            putsU1("Reset Failed");
            clear_display(); //clear the LCD display
            position_cursor(0); //position cursor to row 2
            write_string_LCD((char*) "Reset Failed"); //outputs Message 
            break;
        }
        else {
            clrstr(s);
            putsU2("AT+RST");}
         }while (1);
    delay(500);
    clrstr(s);

    
    
    putsU2("AT+CWJAP?"); // check if already connected to AP
    do {
        delay(500);
        putsU1(s);
        if (strstr(s,SSID) != NULL) {
            putsU1("already connected to wifi ap");
            position_cursor(16); //position cursor to row 1
            write_string_LCD((char*) "Alrdy connected to wifi ap"); //outputs Message
            connection=1;
            break;
        } else if (strstr(s, "ERROR") != NULL) {
            putsU1("connecting to access point...");
            //clear_display(); //clear the LCD display
            position_cursor(16); //position cursor to row 1
            write_string_LCD((char*) "connecting to   access point..."); //outputs Message
            connection=0;
            break;
        }
          else 
          {
              break;
          }
    } while (1);
    clrstr(s);


    char cmd[100];
    clrstr(cmd);
    if (connection == 0) { //if not connected
        strcat(cmd, "AT+CWJAP=\"");
        strcat(cmd, SSID);
        strcat(cmd, "\",\"");
        strcat(cmd, password);
        strcat(cmd, "\"");
        putsU2(cmd);
        
        
        do {
            delay(2000);
            putsU1(s);
            if (strstr(s, "OK") != NULL) {
                putsU1("connected to wifi ap");
                clear_display(); //clear the LCD display
                position_cursor(0); //position cursor to row 1
                write_string_LCD((char*) "WiFi Connected!"); //outputs Message
                connection =1;
                break;
            } else if (strstr(s, "FAIL") != NULL) {
                //putsU2("AT+CWQAP"); //quite access point
                putsU1("failed to connect, let me try again");
                clear_display(); //clear the LCD display
                position_cursor(0); //position cursor to row 1
                write_string_LCD((char*) "Connect Failed  Let me try again"); //outputs Message
                putsU2("AT+CWQAP");
                delay(100);

                clrstr(s);
                putsU2(cmd);
                delay(100);
            }
            /*else {
                putsU1("failed to connect, let me try again");
                clear_display(); //clear the LCD display
                position_cursor(0); //position cursor to row 1
                write_string_LCD((char*) "Connect Failed  Let me try again"); //outputs Message
                putsU2("AT+CWQAP");
                delay(500);

                clrstr(s);
                putsU2(cmd);
            }*/
            
            clrstr(s);

        } while (1);
        clrstr(s);

    }

  
    //set mode

    do {
        putsU2("AT+CWMODE=3"); 
        delay(100);
        if (!(strstr(s, "OK") || !(strstr(s, "no change")))) {
            putsU1("Mode set");
            break;
        } else {
            putsU1("problem setting mode");
        }
    } while (1);
    clrstr(s);




    //set mux to multiple connection mode
    putsU2("AT+CIPMUX=1"); 
    do {
        delay(100);
        if (strstr(s, "OK") != NULL) {
            putsU1("Mux set");
            break;
        } else {
            putsU1("problem setting mode");
            break;
        }
    } while (1);
    clrstr(s);


    //initialize server connection on port 80
        putsU2("AT+CIPSERVER=1,80");
    do {
        delay(100);
        if (strstr(s, "OK") != NULL) {
            putsU1("ESP Initialized as AP");
            break;
        } else {
            putsU1("problem setting ESP as AP");
            break;
        }
    } while (1);
    clrstr(s);


    //find and display IP address
    //The second line returned is the appropriate IP address to connect to
    putsU2("AT+CIFSR");
    do {
        delay(100);
        putsU1(s);
        if (strstr(s, "OK") != NULL) {
            char * address;
            char * address2;
            char * address3;
            int IPlen=0;
            address=strstr(s,"\n"); // search for first terminator
            address2=strstr(address+1,"\n"); //search for second terminator
            address3=strstr(address2+1,"\n"); //search for third terminator
            IPlen=(address3-1)-(address2+1); // subtract to get IP length
            clear_display();
          
            position_cursor(1); //position cursor to row 1
            write_string_LCD("Navigate to:"); //outputs Message1 to display

            position_cursor(16); //position cursor to row 2
            write_array_LCD(address2+1,IPlen); //display IP address
            
            putsU1("Found IP Address");
            break;
        } else {
            putsU1("problem finding IP Address");
            break;
        }
    } while (1);
    clrstr(s);

}
